SystemOrganization addCategory: #ConfigurationOfGTExamples!

Object subclass: #ConfigurationOfGTExamples
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfGTExamples'!

!ConfigurationOfGTExamples class methodsFor: 'development support' stamp: 'StefanReichhart 7/11/2016 16:59'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>! !

!ConfigurationOfGTExamples class methodsFor: 'private' stamp: 'StefanReichhart 7/11/2016 16:59'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #'ConfigurationOf'
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #'ConfigurationOf' ifAbsent: aBlock ].! !

!ConfigurationOfGTExamples class methodsFor: 'private' stamp: 'StefanReichhart 7/11/2016 16:59'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfGTExamples class methodsFor: 'private' stamp: 'StefanReichhart 7/11/2016 16:59'!
ensureMetacelloBaseConfiguration
  Smalltalk
    at: #'ConfigurationOf'
    ifAbsent: [ 
      | repository version |
      repository := MCHttpRepository
        location: 'http://smalltalkhub.com/mc/dkh/metacello/main'
        user: ''
        password: ''.
      repository
        versionReaderForFileNamed: 'Metacello-Base-dkh.107'
        do: [ :reader | 
          version := reader version.
          version load.
          version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfGTExamples class methodsFor: 'metacello tool support' stamp: 'StefanReichhart 7/11/2016 16:59'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfGTExamples class methodsFor: 'loading' stamp: 'StefanReichhart 7/11/2016 16:59'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfGTExamples class methodsFor: 'loading' stamp: 'StefanReichhart 7/11/2016 16:59'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfGTExamples class methodsFor: 'loading' stamp: 'StefanReichhart 7/11/2016 16:59'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfGTExamples class methodsFor: 'accessing' stamp: 'StefanReichhart 7/11/2016 16:59'!
project

	^self new project! !

!ConfigurationOfGTExamples class methodsFor: 'development support' stamp: 'StefanReichhart 7/11/2016 16:59'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfGTExamples methodsFor: 'baselines' stamp: 'TudorGirba 8/19/2016 09:06'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/Moose/GToolkit/main/'.
		spec 
			package: 'GT-Examples';
			package: #'GT-Examples-Dummies' with: [
				spec requires: #('GT-Examples' ). ];
			package: 'GT-Examples-Examples' with: [
				spec requires: #('GT-Examples' ). ];
			package: 'GT-Tests-Examples' with: [
				spec requires: #('GT-Examples-Examples' #'GT-Examples-Dummies' ). ].
		spec group: 'Default' with: #('GT-Examples-Examples' 'GT-Examples' 'GT-Tests-Examples' #'GT-Examples-Dummies' ). ].
! !

!ConfigurationOfGTExamples methodsFor: 'accessing' stamp: 'StefanReichhart 7/11/2016 16:59'!
customProjectAttributes
    "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes "

    ^ #()! !

!ConfigurationOfGTExamples methodsFor: 'symbolic versions' stamp: 'StefanReichhart 7/11/2016 16:59'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.
! !

!ConfigurationOfGTExamples methodsFor: 'accessing' stamp: 'StefanReichhart 7/11/2016 16:59'!
project
    ^ project
        ifNil: [ 
            "Bootstrap Metacello if it is not already loaded"
            self class ensureMetacello.
            project := MetacelloMCProject new projectAttributes: self customProjectAttributes.	"Create the Metacello project"
            (Smalltalk at: #'MetacelloVersionConstructor') on: self project: project.	"Construct the project"
            project loadType: #'linear'.	"change to #atomic if desired"
            project ]! !
